
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java面向对象-3-方法参数传递 / 憋错料</title>

    <meta name="description" content="java面向对象-3-方法参数传递 java的方法不能独立存在,一定是在类中的,并且java中方法的参数一定是值传递的.但是,有时候因为参数是引用类型,比如String类型,数组类型,String str=&quot;hello world&quot;;str这个标识符所指向的内存块并不是&quot;hello world&quot;那个内存块,而是&quot;hello world&quot;内存块的地址.这个时候,我们就会发现,java中方法参数传递感觉不是值传递,因为方法操作完后,原来的值也变了,其实不是,这只是我们的错觉. ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">java面向对象-3-方法参数传递</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>java的方法不能独立存在，一定是在类中的，并且java中方法的参数一定是值传递的。但是，有时候因为参数是引用类型，比如String类型，数组类型，String str=“hello world”;str这个标识符所指向的内存块并不是“hello world”那个内存块，而是“hello world”内存块的地址。这个时候，我们就会发现，java中方法参数传递感觉不是值传递，因为方法操作完后，原来的值也变了，其实不是，这只是我们的错觉。方法操作完之后，str所代表的地址并没有变，而是指向的那块内存里的内容变了。</p>
<p>而基本数据类型，例如int a=5; 其中a代表的内存里，存放的就是5，所以方法操作后，并没有变。如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEEvQTIvd0tpb20xZzFucExoNkM2akFBQkFYV2NuMzUwNTIwLnBuZw==.jpg" /></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 04:09:47 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%b9%e6%b3%95%e5%8f%82%e6%95%b0/" title="方法参数">方法参数</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>java面向对象-3-方法参数传递的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyqWmVM.html" rel="bookmark">JAVA 面向对象之方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本页面更新日期: 2016年07月18日 前言 方法是类或对象 的行为特征的抽象. 方法是类或对象最重要的组成部分. 所有的方法都必需定义在类里. 方法不能独立存在. 方法在逻辑上要么属于类, 要么属于对象. 方法的所属性 一旦将一个方法定义在某个类的类体内. 如果这个方法使用了static修饰符,则这个方法属于这个类. 否则这个方法属于这个类的实例. Java语言是静态的. 一个类定义完成后,只要不再重新编译这个类文件,该类和该类的对象所拥有的方法是固定的,永远都不会改变. 执行方法时必需使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xDD7n0.html" rel="bookmark">Java面向对象-方法的定义及简单使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java面向对象之方法 方法是对象的一部分,也称为行为: 先来一个简单实例: 1 package com.java1234.chap03.sec03; 2 3 public class Person { 4 5 void speak(){ 6 System.out.println(&quot;我是张三&quot;); 7 } 8 9 public static void main(String[] args) { 10 Person person=new Person(); 11 person.speak			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38ZolgM.html" rel="bookmark">理解JAVA - 面向对象&lpar;object&rpar; - 属性，方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				理解JAVA - 面向对象(object) - 属性,方法 多态的体现:    向上造型,父类接收子类对象:向上造型:    从父类角度看不到子类独有的方法: 面向对象,人类认知世界的方式:生活中每天都在多态:    这个人是谁,这是个人,多态来看待他了:    他是老师  把它向下造型来看待了,他是老师,知道他能讲课了,老师是人下面的子类型: 我们每天都已多态来接收事物,然后向下造型:    这是人,这人是老师:    这是车,这车是奥迪 小时候,不知到是什么,就问这是什么东西,世间万物都能成			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35bpjv4.html" rel="bookmark">Java 面向对象 的属性  和 方法 的使用 （Java 学习中的小记录）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java 面向对象 的属性  和 方法 的使用        作者:王可利(Star·星星) //car 的属性方法 class Car { //属性 格式:数据类型 变量名 String color; String name; int wheelNumber; public void run(){ System.out.println(&quot;run 的方法 汽车启动了~&quot;); } } //主函数的方法 class Star1 { public static void main(Strin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0env8b3.html" rel="bookmark">java面向对象编程（六）--四大特征之继承、方法重载和方法覆盖</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.继承 1.继承的概念 继承可以解决代码复用,让我们的编程更加靠近人类思维.当多个类存在相同的属性(变量)和方法时,可以从这些类中抽象出父类,在父类中定义这些相同的属性和方法,所有的子类不需要重新定义这些属性和方法,只需要通过extends语句来声明继承父类.语法如下: class 子类 extends 父类 这样,子类就会自动拥有父类定义的某些属性和方法.另外,并不是父类的所有属性.方法都可以被子类继承.父类的public修饰符的属性和方法,protected修饰符的属性和方法,默认修饰符属			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPW21n4.html" rel="bookmark">Java中方法参数传递的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				可以理解当我们要调用一个方法时,我们会把指定的数值,传递给方法中的参数,这样方法中的参数就拥有了这个指定的值,可以使用该值,在方法中运算了.这种传递方式,我们称为参数传递.在这里,定义方法时,参数列表中的变量,我们称为形式参数. 调用方法时,传入给方法的数值,我们称为实际参数 在Java中调用方法时,如果参数是基本类型(byte/short/int/long/float/double/char/boolean)以及String类型时,形式参数的改变不影响实际参数. 以下代码在内存中发生的动作:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bqyV9M.html" rel="bookmark">Java方法参数传递</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				方法体的概念.先有类,然后由类来生成对象,对象又叫做实例 类由两大部分构成:属性及方法.属性一般用名词来表示,方法一般用动词来表示 如果一个Java原文家定义多个类,那么这些类中只能有一个public的换句话说定义的多个类可以都不是public的 在Java中进行方法的参数传递时,无论是传递是原生数据类型还是引用数据类型,参数传递方式统一是传值,Java中没有传递引用的概念			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eE8Jv0.html" rel="bookmark">Java方法参数传递（swap函数）（转载）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java里方法的参数传递方式只有一种:值传递.值传递,就是将实际参数值的副本(复制品)传入方法内,而参数本身不会受到任何影响. public class PrimitiveTransferTest { public static void swap(int a,int b) { int temp=a; a=b; b=temp; System.out.println(&quot;swap方法里,a的值是&quot;+a+&quot;;b的值是&quot;+b); } public static void m			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm7GlQ3.html" rel="bookmark">Java面向对象-方法的重载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java面向对象-方法的重载 所谓方法的重载, 类里面有两个或者多个重名的方法,但是方法的参数个数.类型.顺序至少有一个不一样,这时候局构成方法重载: 上代码: 1 package com.java1234.chap03.sec03; 2 3 public class Demo01 { 4 5 int add(int a,int b){ 6 System.out.println(&quot;方法一&quot;); 7 return a+b; 8 } 9 10 /** 11 * 方法的重载,参数个数不一样			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgEv83.html" rel="bookmark" class="title">Oyk的ACM刷题记录（始于2015年2月29日，可能含剧透）</a>
					<div>
						Online Judge 题目序号/题目 简单大意/题解 犯2情况 2月29日 SPOJ GSS1  不带更新区间最大子段和. 线段树维护 区间从左/右开始的最大值.区间最大值.区间和. 1.输出忘了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0x7RkM.html" rel="bookmark" class="title">servlet总结</a>
					<div>
						Servlet总结 1.Servlet负责用来在服务器端处理用户的请求,当客户端发送一个请求给服务器,服务器通过web.xml配置文件找到相应的Servlet,从而处理这个请求.一个servlet要和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bynqYM.html" rel="bookmark" class="title">Java单例模式以及线程安全性的保证</a>
					<div>
						1.单例模式有什么用处? 有一些对象只能使用一个,例如:数据库连接.线程池(threadpool).缓存(cache).对话框.处理偏好(preferences)设置和这侧表(registry)的对象 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4APQvZ3.html" rel="bookmark" class="title">Android重写FragmentTabHost来实现状态保存</a>
					<div>
						分类: android 2014-06-27 17:57 2077人阅读 评论(0) 收藏 举报 FragmentTabHost 最近要做一个类似QQ底部有气泡的功能,试了几个方案不太好,我想很多开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqzjE0.html" rel="bookmark" class="title">关系模式设计理论 - 数据库系统原理</a>
					<div>
						模式设计理论主要包括三方面的内容:数据依赖.范式.模式设计方法.数据依赖研究数据之间的联系,起着核心的作用:范式是关系模式的标准:模式设计方法是自动化设计的基础. 关系模式的设计准则 关系模式的冗余和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0enJab3.html" rel="bookmark" class="title">190&period; Reverse Bits（leetcode）</a>
					<div>
						Reverse bits of a given 32 bits unsigned integer. For example, given input 43261596 (represented in  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgoLv3.html" rel="bookmark" class="title">hduacm  5255</a>
					<div>
						http://acm.hdu.edu.cn/showproblem.php?pid=5255 枚举a和c  求解b #include &lt;cstdio&gt; #include &lt;cstri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLWBek4.html" rel="bookmark" class="title">jquery ui bootstrap日期插件</a>
					<div>
						http://blog.csdn.net/php_897721669/article/details/7404527 搜索“jquery ui日期插件怎么显示年份”? $(&quot;#datepic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZroNL3.html" rel="bookmark" class="title">libxml的使用（1）--读取xml</a>
					<div>
						libxml是一个用于解析xml文件的库,在各个平台下都能使用,也支持多种语言,如c,Python等.这里是官方网站.上面有libxml的api和一些code examples,都是英文的.不过比较简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7aWE4.html" rel="bookmark" class="title">网页-豌豆上的公主</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WN5n0.html" rel="bookmark" class="title">Tokyo Tyrant（TTServer）系列（六）－数据丢失谁的错</a>
					<div>
						前面的一些文章讲到了memcache以及TT,memcache内存数据库很好理解,数据存储在内存中,重启服务器或者重启memcahce进程,数据是会丢失的.那么我们也提到过TTServer数据是持久存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41znvkM.html" rel="bookmark" class="title">2017&period;3&period;24计算机笔记</a>
					<div>
						150206115					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7Nn53.html" rel="bookmark" class="title">高德导航功能模块</a>
					<div>
						主要代码: public class MainActivity extends BaseActivity { private EditText edit_end_lng; private EditTe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8R27M.html" rel="bookmark" class="title">bootstrap框架的使用</a>
					<div>
						bootstrap 1.首先要引入外部css文件在html中! 一共为4个 分别是: bootstrap.css bootstrap.min.css bootstrap-theme.css boots ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm92BQM.html" rel="bookmark" class="title">Redis 4&period;0&period;1集群搭建</a>
					<div>
						Redis 4.0.1集群搭建 一.概述 Redis3.0版本之后支持Cluster. 1.1.redis cluster的现状 目前redis支持的cluster特性: 1):节点自动发现 2):s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ob8g0.html" rel="bookmark" class="title">ionic使用ion-scroll实现竖向侧边可滚动菜单栏</a>
					<div>
						看看效果 ,如图使用ioc-scroll就可以实现左侧的菜单栏,可滚动,当然是跟右边(ion-content)的内容分开的,互不干扰. html: js: css:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQLql0.html" rel="bookmark" class="title">CI框架后台添加左侧导航栏出现的一系列问题</a>
					<div>
						后台在数据库中添加了一个栏目.但是但点击这个新添加的栏目之后,却发现左侧的导航栏没有了,,为什么呢. 注意CI框架下在shared/libraries/Acl.php这个文件,(后台权限控制类) 里边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGE5q4.html" rel="bookmark" class="title">NPOI-Excel系列-1002&period;创建带有Document Summary Information和Summary Information的Excel文件</a>
					<div>
						1. 1 using NPOI.HSSF.UserModel; 2 using NPOI.HPSF; 3 using NPOI.POIFS.FileSystem; 4 using Microsoft. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVpg2k3.html" rel="bookmark" class="title">对于整数幂打表的一个技巧</a>
					<div>
						如果我们需要在某个整数区间打一个幂表的话,有一个方法比较好用,比如我们要在1~5000之间,打满     1^1,    1^2,    1^3...............    1^5000    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RLPo94.html" rel="bookmark" class="title">Sublime Text 3破解补丁</a>
					<div>
						转载自https://www.shuax.com/archives/SublimeText3Crack.html 包括32位和64位破解补丁,请自行选用,把dll放到st目录下即可.支持st自动更新, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
